import java.io.*;
import java.util.*;

class Coord
{ 
  public int r,c;
  public Coord( int r, int c)
  {
    this.r=r; this.c=c;
  }
}

public class Bfs
{
  float factor;

  public void printBfs()
  {
    printBfs(this.data);
  }

  public static void printBfs(int[][] data)
  {
    for(int i=0; i<data.length; i++)
    {
      for(int j=0; j<data[i].length; j++)
      {
        /*
        String output = String.valueOf(data[i][j]);
        while (output.length() < 2) output = "0"+output;
        if (output.length() > 2) output = "XX";
        */
        String output = String.valueOf(data[i][j]);
        while (output.length()<4)
          output = " " + output;
        if (data[i][j] == -1000000000)
          System.out.print("XXXX ");
        else
        System.out.print( output+" ");
      }
      System.out.println();
    }
  }

  private int[][] data;
  
  public int valueOf(int r, int c)
  {
    return shortestDistanceTo(r,c);
  }

  public int shortestDistanceTo(int r, int c)
  {
    return data[r][c];
  }

  public Bfs( World w, int r, int c)
  {
    data = new int[w.board.length][w.board[0].length];
    for (int i=0;i<data.length;i++) for (int j=0;j<data[0].length;j++)
      data[i][j]=-1000000000; /* We cannot get there */
    
    ArrayList queue = new ArrayList();
    queue.add( new Coord(r,c));
    data[r][c]=0;
    while (queue.size()>0)
    {
      Coord o = (Coord)queue.remove(0);
      for (int i=-1;i<=1;i++) for (int j=-1;j<=1;j++)
        if ( i != j && i*j == 0
             && o.r+i > 0 && o.r+i < data.length && o.c+j > 0 && o.c+j < data[0].length
             && w.board[o.r+i][o.c+j] != '#' && w.board[o.r+i][o.c+j] != '~'
             && (data[o.r+i][o.c+j] == -1000000000 || data[o.r+i][o.c+j] > data[o.r][o.c]+1))
        {
          queue.add(new Coord(o.r+i,o.c+j));
          data[o.r+i][o.c+j] = data[o.r][o.c]+1; 
        }
    }
    printBfs();
  }

  public Bfs( World w, ArrayList pots)
  {
    int[][] t = new int[w.board.length][w.board[0].length];
    data = new int[t.length][t[0].length];
    for (int j=0;j<t.length;j++) for (int k=0;k<t[0].length;k++)
      data[j][k]=0;

    for (int p=0;p<pots.size();p++)
    {
      for (int j=0;j<t.length;j++) for (int k=0;k<t[0].length;k++)
        t[j][k] = 0;
      Functor f = (Functor)pots.get(p);
      int incrementor =0;
      if (f.value > 0) incrementor = -1;
      if (f.value == 0) continue;
      if (f.value < 0) incrementor =1;
      
      factor = (float) Math.sqrt(t.length*t.length + t[0].length*t[0].length)*5.0f;
      
      ArrayList queue = new ArrayList();
      queue.add(new Coord(f.getY(),f.getX()));
      t[f.getY()][f.getX()] = (int) (f.value*factor+0.5);
      System.out.println("Factor: "+factor+ ", initial value: "+(f.value*factor+0.5));
      if (t[f.getY()][f.getX()] == 0) continue;
      while (queue.size()>0)
      {
        Coord c = (Coord)queue.remove(0);
        for (int i=-1;i<=1;i++) for (int j=-1;j<=1;j++)
          if ( i != j && i*j == 0
               && c.r+i > 0 && c.r+i < t.length && c.c+j > 0 && c.c+j < t[0].length
               && w.board[c.r+i][c.c+j] != '#' && w.board[c.r+i][c.c+j] != '~'
               && (t[c.r+i][c.c+j]+incrementor != 0 && Math.abs(t[c.r+i][c.c+j]) < Math.abs(t[c.r][c.c]+incrementor)))
          {
            queue.add(new Coord(c.r+i,c.c+j));
            t[c.r+i][c.c+j] = t[c.r][c.c]+incrementor; 
          }
        
      }
      for (int i=0;i<t.length;i++) for (int j=0;j<t[0].length;j++)
        data[i][j] += t[i][j];
    }//for pots

    for (int i=0; i<data.length; i++) for (int j=0;j<data[0].length;j++)
      if (w.board[i][j] == '#' || w.board[i][j] == '~') data[i][j] = -1000000000;
    printBfs();
  }
  
  
  
  static int[][] bfs;
  static LineNumberReader lnr = new LineNumberReader(new BufferedReader(new InputStreamReader(System.in)));
  public static void main(String[] args) throws Exception
  {
    /*
    String s = lnr.readLine();
    int r = Integer.parseInt(s.substring(0,s.indexOf(' ')));
    int c = Integer.parseInt(s.substring(s.indexOf(' ')).trim());
    
    s = lnr.readLine();
    int startRow = Integer.parseInt(s.substring(0,s.indexOf(' ')))-1;
    int startCol = Integer.parseInt(s.substring(s.indexOf(' ')).trim())-1;
   
    char[][] board = new char[r][c];
    bfs = new int[r][c];
    for (int i=0; i<r; i++)
    {
      s = lnr.readLine();
      for (int j=0; j<c; j++)
      {
        board[i][j] = s.charAt(j);
        bfs[i][j] = -1;
      }
    }

    ArrayList queue = new ArrayList();
    System.out.println("Initial size "+queue.size());
    queue.add( new Coord(startRow,startCol) );
    bfs[startRow][startCol]=0;
    while (queue.size()>0)
    {
      Coord pos = (Coord) queue.remove(0);
      System.out.println("Visiting r:"+pos.r+" c:"+pos.c);
      for (int i=-1; i<=1; i++) for (int j=-1; j<=1; j++)
        if ( i*j == 0 && i!=j 
             && 0 <= i+pos.r && i+pos.r < r && 0 <= j+pos.c && j+pos.c < c
             && board[i+pos.r][j+pos.c] != '~' && board[i+pos.r][j+pos.c] != '#' 
             && (bfs[i+pos.r][j+pos.c] > bfs[pos.r][pos.c]+1 || bfs[i+pos.r][j+pos.c] == -1))
        {
          System.out.println("Pushing r:"+(i+pos.r)+" c:"+(j+pos.c));
          printBfs();
          bfs[i+pos.r][j+pos.c] = bfs[pos.r][pos.c]+1;
          queue.add(new Coord(i+pos.r, j+pos.c));
        }
    }
    printBfs();
  */
  }
}
