import java.net.*;
import java.util.*;
import java.io.*;

public class Server
{

  class Packet
  {
    public int sx, sy, ex, ey, weight, id;
    public Packet(int _sx, int _sy, int _ex, int _ey, int _weight, int _id)
    {
      sx = _sx;
      sy = _sy;
      ex = _ex;
      ey = _ey;
      weight = _weight;
      id = _id;
    }
  }
  
  public static char[][] board;
  
  public static ArrayList clients, robots, packets;
  public static LineNumberReader lnr = null;
  
  public static LineNumberReader getLNR( InputStream is )
  {
    return new LineNumberReader( new BufferedReader(new InputStreamReader(is) ) );
  }
  
  public static StringTokenizer getST( String s )
  {
    return new StringTokenizer(s);
  }
  
  public static void sendToAll(String s)
  {
    for (int i=0; i<clients.size(); i++)
      ((Socket)clients.get(i)).getOutputStream().write (s.getBytes());
  }
  
  public static void main (String[] args)
  {
    clients = new ArrayList();
    robots = new ArrayList();
    packets = new ArrayList();
    Socket temp =null;
    StringTokenizer st;
    String positions = new String();
    Robot rtemp;
    Packet ptemp;
      
    ServerSocket client = new ServerSocket (Integer.parseInt(args[0]));
    for (int i=0; i<Integer.parseInt(args[1]); i++)
    {
      temp = client.accept();
      lnr = getLNR(temp.getInputStream());
      if (lnr.readLine().equals("Player"))
        clients.add(temp);
      else
        temp.close();
    }
    //all clients are connected
    lnr = getLNR(System.in);
    String line = lnr.readLine();
    int rows = Integer.parseInt(line.substring(0,line.indexOf(' ')));
    int cols = Integer.parseInt(line.substring(line.indexOf(' ')).trim());
    board = new char[rows][cols];
    for (int i=0; i<rows; i++)
    {
      line = lnr.readLine();
      sendToAll(line);
      line.getChars(0,cols,board[i],0);
    }
    
    for (int i=0; i<clients.size(); i++)
    {
      line = lnr.readLine();
      ((Socket)clients.get(i)).getOutputStream().write(line.getBytes());
      st = getST(line);
      rtemp = Robot.create(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()), i+1);
      robots.add(rtemp);
    }
    
    for (int i=0; i<clients.size(); i++)
    {
      line = lnr.readLine();
      st = getST(line);
      rtemp = (Robot) robots.get(i);
      rtemp.setPos (Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()));
      
      positions = positions + "#" + rtemp.id + " X " + rtemp.x + " Y " + rtemp.y + " ";
    }
    sendToAll (positions.trim());

    line = lnr.readLine();
    int numPackets = Integer.parseInt(line);
    for (int i=0; i<numPackets; i++)
    {
      line = lnr.readLine();
      st = getST(line);
      ptemp = new Packet(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()),
                         Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()),
                         Integer.parseInt(st.nextToken()));
      packets.add(ptemp);
    }
  }
}
