import java.util.*;
import java.io.*;

public class genScore
{
  static int numRobots;
  static int numParams;
  static Random rand;
    
  public static String toBits (int[] p)
  {
    String genome = new String();
    String temp;
    for (int i=1; i<p.length; i++)
    {
      temp = Integer.toBinaryString(p[i]);
      while (temp.length()<8)
        temp = "0" + temp;
      genome = genome + temp;
    }
    return genome;
  }

  public static int[] toBytes (String a)
  {
    int[] p = new int[a.length()/8];
    int j = 0;
    String b;
    
    for (int i=0; i<a.length()/8; i++)
    {
      b = a.substring (j, j+8);
      p[i] = Integer.parseInt (b, 2);
      j+= 8;
    }

    return p;
  }

  public static String cross (String a, String b)
  {
    String c;
    int x = rand.nextInt (a.length()) + 1;
    c = a.substring (0, x) + b.substring (x, b.length());
    c = mutate(c);
    return c;
  }

  public static String mutate (String a)
  {
    String c;
    int iters = 3;
    int x;
    char y;

    c = new String(a);
    for (int i=0; i<iters; i++)
    {
      x = rand.nextInt (a.length());
      y = c.charAt (x);
      if (y=='0')
        y = '1';
      else
        y = '0';
      c = c.substring (0, x) + y + c.substring (x+1, c.length());
    }

    return c;
  }
  
  public static void main (String[] args) throws IOException
  {
    numRobots = 10;
    numParams = 14;
    String params;
    String[] topG = new String[4];
    String[] newG = new String[10];
    int newGcount;
    int[][] mults = new int[numRobots][numParams];
    rand = new Random();
    
    if (args.length<2)
    {
      System.out.println ("Arguments:\n1) input filename / 'none'\n2) output filename");
      return;
    }
    if (args[0].equals("none"))
    {
      //generate new nums
      FileWriter out = new FileWriter (args[1]);

      for (int i=0; i<numRobots; i++)
      {
        params = new String();
        for (int j=0; j<numParams; j++)
        {
          params = params + " " + rand.nextInt (256);
        }
        params = params.trim();
        out.write (params, 0, params.length());
        out.write (10);
      }
      out.close();
    }
    else
    {
      FileReader in = new FileReader (args[0]);
      LineNumberReader lnr = new LineNumberReader (in);
      FileWriter out = new FileWriter (args[1]);
      StringTokenizer st;
      int[] inParams = new int[numParams+1];
      multSort inSort = new multSort (numRobots, numParams);

      for (int i=0; i<numRobots; i++)
      {
        st = new StringTokenizer(lnr.readLine());
        for (int j=0; j<numParams+1; j++)
        {
          inParams[j] = Integer.parseInt (st.nextToken());
        }
        inSort.add(inParams);
      }
      inSort.sort();

      topG[0] = toBits (inSort.get(0));
      topG[1] = toBits (inSort.get(1));
      topG[2] = toBits (inSort.get(2));
      topG[3] = toBits (inSort.get(rand.nextInt(6)+4));

      newGcount = 0;
      for (int i=0; i<3; i++)
      {
        for (int j=i+1; j<4; j++)
        {
          newG[newGcount] = cross(topG[i], topG[j]);
          newGcount++;
        }
      }
      for (int i=0; i<4; i++)
      {
        newG[newGcount] = mutate (topG[i]);
        newGcount++;
      }
      
      for (int i=0; i<numRobots; i++)
      {
        inParams = toBytes (newG[i]);
        params = new String();
        for (int j=0; j<numParams; j++)
        {
          if (inParams[j]==0)
            inParams[j]++;
          params = params + " " + inParams[j];
        }
        params = params.trim();
        out.write (params, 0, params.length());
        out.write (10);
      }
      out.close();
      
      /*for (int i=0; i<numRobots; i++)
      {
        inSort.get(inParams, i);
        params = new String();
        for (int j=0; j<numParams+1; j++)
        {
          params = params + " " + inParams[j];
        }
        params = params.trim();
        out.write (params, 0, params.length());
        out.write (10);
      }
      out.close();*/
      
    }
  }
}
