#include <fstream>
#include <queue>

using namespace std;

const int dx[4] = {+1,  0, -1,  0};	// Move in x
const int dy[4] = { 0, +1,  0, -1};	// Move in y

void main() {

	ifstream in; in.open("icfp.in");
	ofstream out; out.open("icfp.out");

	int rows, cols, i, j, mr, mc, row, col, nx, ny, cur;
	char board[200][200];		// Assume max size = 200
	short BFS[200][200] = {0};	
	bool visited[200][200] = {0};
	queue<int> Q;

	while (1) {

		in >> rows >> cols;
		if (rows < 0) break;
		// Read board
		for (i = 0; i < rows; i++)
			for (j = 0; j < cols; j++) {
				in >> board[i][j];
				if (board[i][j] == 'U') { mr = i; mc = j; }		// mr = my_row, etc.
			}
		// Now, from our position, do a BFS...
		Q.push(mr * rows + mc);			// Push starting spot
		visited[mr][mc] = true;			
		while (Q.size() > 0) {			
			cur = Q.front();			
			Q.pop();
			row = cur / rows; col = cur % rows;
			out << row << " " << col << endl;
			for (i = 0; i < 4; i++) {
				nx = row + dx[i]; ny = col + dy[i];
				if (nx < rows && nx >= 0 && ny < cols && ny >= 0 && abs(nx - mr) < 50 
					&& abs(ny - mc) < 50 && board[nx][ny] != '#' && board[nx][ny] != '~' 
					&& !visited[nx][ny]) {
					Q.push(nx * rows + ny);
					visited[nx][ny] = true;
					BFS[nx][ny] = BFS[row][col] + 1;
				}
			}
		}
		// Print out BFS matrix
		for (i = 0; i < rows; i++) {
			for (j = 0; j < rows; j++) out << BFS[i][j] << " ";
			out << endl;
		}
	}		
	in.close(); out.close();
}